Index: trunk/kernel/drivers/soclib/soclib_pic.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_pic.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_pic.c	(revision 1)
@@ -0,0 +1,120 @@
+/*
+ * soclib_pic.c - soclib PIC driver implementation.
+ *
+ * Author  Alain Greiner (2016)
+ * *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH. is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH. is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <hal_types.h>
+#include <device.h>
+#include <soclib_pic.h>
+#include <soclib_xcu.h>
+#include <errno.h>
+#include <string.h>
+#include <vfs.h>
+
+
+//////////////////////////////////////
+void soclib_pic_init( xptr_t  dev_xp )
+{
+    // get PIC device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+  
+    // get extended pointer on PIC segment base from PIC device descriptor
+    xptr_t seg_xp = (xptr_t)hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+ 
+    // get PIC controller segment cluster and local pointer
+    cxy_t      seg_cxy = (cxy_t)GET_CXY( seg_xp );
+    uint32_t * seg_ptr = (uint32_t *)GET_PTR( seg_xp );
+    uint32_t   i;
+
+    // reset the MASK registers for all input IRQs
+    for( i = 0 ; i < CONFIG_MAX_IRQS_PER_PIC ; i++ )
+    {
+        hal_remote_sw( XPTR( seg_cxy , seg_ptr + i*IOPIC_SPAN + IOPIC_MASK ) , 0 ); 
+    }
+}
+
+////////////////////////////////////////////
+void soclib_pic_bind_irq( xptr_t     dev_xp,
+                          uint32_t   irq_id,
+                          xptr_t     xp_wti )
+{
+    // get PIC device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+  
+    // get extended pointer on PIC segment base from PIC device descriptor
+    xptr_t seg_xp = (xptr_t)hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+ 
+    // get PIC controller segment cluster and local pointer
+    cxy_t      seg_cxy = (cxy_t)GET_CXY( seg_xp);
+    uint32_t * seg_ptr = (uint32_t *)GET_PTR( seg_xp );
+
+    uint32_t lsb = (uint32_t)xp_wti;
+    uint32_t msb  = (uint32_t)(xp_wti>>32);
+
+	// set the IOPIC_ADDRESS and IOPIC_EXTEND registers
+    hal_remote_sw( XPTR( seg_cxy , seg_ptr+irq_id*IOPIC_SPAN+IOPIC_ADDRESS ) , lsb );
+    hal_remote_sw( XPTR( seg_cxy , seg_ptr+irq_id*IOPIC_SPAN+IOPIC_EXTEND  ) , msb );
+
+    // set IOPIC_MASK register
+    hal_remote_sw( XPTR( seg_cxy , seg_ptr+irq_id*IOPIC_SPAN+IOPIC_MASK    ) , 1   );
+}
+
+//////////////////////////////////////////////
+void soclib_pic_unbind_irq( xptr_t     dev_xp,
+                            uint32_t   irq_id )
+{
+    // get PIC device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+  
+    // get extended pointer on PIC segment base from PIC device descriptor
+    xptr_t seg_xp = (xptr_t)hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+ 
+    // get PIC controller segment cluster and local pointer
+    cxy_t      seg_cxy = (cxy_t)GET_CXY( seg_xp);
+    uint32_t * seg_ptr = (uint32_t *)GET_PTR( seg_xp );
+
+    // set IOPIC_MASK register
+    hal_remote_sw( XPTR( seg_cxy , seg_ptr+irq_id*IOPIC_SPAN+IOPIC_MASK    ) , 0   );
+}
+
+//////////////////////////////////////////////
+void soclib_pic_get_status( xptr_t     dev_xp,
+                            uint32_t   irq_id,
+                            uint32_t * status)
+{
+    // get PIC device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+  
+    // get extended pointer on PIC segment base from PIC device descriptor
+    xptr_t seg_xp = (xptr_t)hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+ 
+    // get PIC controller segment cluster and local pointer
+    cxy_t      seg_cxy = (cxy_t)GET_CXY( seg_xp);
+    uint32_t * seg_ptr = (uint32_t *)GET_PTR( seg_xp );
+
+    // return status
+	*status = hal_remote_lw( XPTR( seg_cxy , seg_ptr+irq_id*IOPIC_SPAN+IOPIC_STATUS ) );
+}
+
Index: trunk/kernel/drivers/soclib/soclib_pic.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_pic.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_pic.h	(revision 1)
@@ -0,0 +1,83 @@
+/*
+ * soclib_pic.c - soclib PIC driver definition.
+ *
+ * Author  Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_IOPIC_H_
+#define _SOCLIB_IOPIC_H_
+
+#include <hal_types.h>
+
+/******************************************************************************************
+ *  PIC register offsets (per input IRQ)
+ *****************************************************************************************/
+
+#define IOPIC_ADDRESS           0
+#define IOPIC_EXTEND            1
+#define IOPIC_STATUS            2
+#define IOPIC_MASK              3
+#define IOPIC_SPAN              4
+
+/******************************************************************************************
+ * This blocking function desactivates all input IRQs in a remote PIC controler.
+ * It can be called by any thread running on any cluster.
+ ******************************************************************************************
+ * @ dev_xp    : extended pointer on the PIC device descriptor.
+ *****************************************************************************************/
+void   soclib_pic_init( xptr_t dev_xp );
+
+/******************************************************************************************
+ * This blocking function returns the status for a given input IRQ in the remote
+ * PIC controler. It can be called by any thread running on any cluster.
+ ******************************************************************************************
+ * @ dev_xp    : extended pointer on the PIC device descriptor.
+ * @ irq_id    : input IRQ index.
+ * @ status    : pointer on local buffer for returned status.
+ *****************************************************************************************/
+void   soclib_pic_get_status( xptr_t     dev_xp,
+                              uint32_t   irq_id,
+                              uint32_t * status );
+
+/******************************************************************************************
+ * This blocking function unmask an input IRQ in a remote PIC controler, and bind it
+ * with a WTI mailbox, by registering the WTI mailbox extended pointer.
+ * It can be called by any thread running on any cluster.
+ ******************************************************************************************
+ * @ dev_xp    : extended pointer on the PIC device descriptor.
+ * @ irq_id    : input IRQ index.
+ * @ xp_wti    : extended pointer on the WTI mailbox.
+ *****************************************************************************************/
+void   soclib_pic_bind_irq( xptr_t    dev_xp,
+                            uint32_t  irq_id,
+                            xptr_t    wti_xp );
+
+/******************************************************************************************
+ * This blocking function mask an input IRQ in a remote PIC controler.
+ * It can be called by any thread running on any cluster.
+ ******************************************************************************************
+ * @ dev_xp    : extended pointer on the PIC device descriptor.
+ * @ irq_id    : input IRQ index. 
+ *****************************************************************************************/
+void   soclib_pic_unbind_irq( xptr_t    dev_xp,
+                              uint32_t  irq_id );
+
+
+#endif	/* _SOCLIB_IOPIC_H_ */
Index: trunk/kernel/drivers/soclib/soclib_tty.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_tty.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_tty.c	(revision 1)
@@ -0,0 +1,233 @@
+/*
+ * soclib_tty.c - soclib tty driver implementation.
+ *
+ * Author  Alain Greiner (2016)
+ *
+ * Copyright (c)  UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH..
+ *
+ * ALMOS-MKH. is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH. is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <dev_txt.h>
+#include <device.h>
+#include <soclib_tty.h>
+#include <remote_spinlock.h>
+#include <thread.h>
+#include <hal_special.h>
+
+/////////////////////////////////////
+void soclib_tty_init( xptr_t dev_xp )
+{
+    // get TXT device cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get extended pointer on TTY-SOCLIB peripheral base address
+    xptr_t tty_xp = (xptr_t)hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) ); 
+
+    // get SOCLIB_TTY device cluster and local pointer
+    cxy_t      tty_cxy = GET_CXY( tty_xp );
+    uint32_t * tty_ptr = (uint32_t *)GET_PTR( tty_xp );
+  
+    // mask both TTY_RX_IRQ and TTY_TX_IRQ
+    hal_remote_sw( XPTR( tty_cxy , tty_ptr + TTY_CONFIG_REG ) , 0 );
+
+}  // end soclib_tty_init()
+
+//////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_tty_command( xptr_t th_xp )
+{
+    // get client thread cluster and local pointer
+    cxy_t      th_cxy = GET_CXY( th_xp );
+    thread_t * th_ptr = (thread_t *)GET_PTR( th_xp );
+
+    // get command type and extended pointer on TXT device
+    uint32_t type   =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.txt.type ) );
+    xptr_t   dev_xp = (xptr_t)hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.txt.dev_xp ) );
+    
+    // get TXT device cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get extended pointer on SOCLIB_TTY base segment
+    xptr_t tty_xp = (xptr_t)hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get SOCLIB_TTY base segment cluster and local pointer
+    cxy_t      tty_cxy = GET_CXY( tty_xp );
+    uint32_t * tty_ptr = (uint32_t *)GET_PTR( tty_xp );
+
+    if( type == TXT_READ )              // descheduling strategy for calling thead
+    {
+        // unmask RX_IRQ (data transfer will be done by the TTY_RX ISR)
+        xptr_t config_xp = XPTR( tty_cxy , tty_ptr + TTY_CONFIG_REG );
+        uint32_t old = hal_remote_lw( config_xp );
+        uint32_t new = old | TTY_CONFIG_RX_ENABLE;
+        hal_remote_atomic_cas( config_xp , old , new );
+
+        // Block and deschedule server thread 
+        thread_block( CURRENT_THREAD , THREAD_BLOCKED_DEV_ISR );
+        sched_yield();
+    }
+    else if( type == TXT_WRITE )        // descheduling strategy for calling thread
+    {
+        // unmask TX_IRQ (data transfer will be done by the TTY_TX ISR)
+        xptr_t config_xp = XPTR( tty_cxy , tty_ptr + TTY_CONFIG_REG );
+        uint32_t old = hal_remote_lw( config_xp );
+        uint32_t new = old | TTY_CONFIG_TX_ENABLE;
+        hal_remote_atomic_cas( config_xp , old , new );
+
+        // Block and deschedule server thread 
+        thread_block( CURRENT_THREAD , THREAD_BLOCKED_DEV_ISR );
+        sched_yield();
+    }
+    else if( type == TXT_SYNC_WRITE )  // busy waiting strategy for calling thread
+    {
+        uint32_t   status;        
+        bool_t     empty;
+        uint32_t   i;
+
+        // get source buffer extended pointer & bytes count
+        uint32_t count  = hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.txt.count ) );
+        xptr_t   buf_xp = hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.txt.buf_xp ) );
+
+        // loop on characters 
+        for( i = 0 ; i < count ; i++ )
+        { 
+            do
+            {
+                // get TTY_STATUS_REG
+                status = hal_remote_lw( XPTR( tty_cxy , tty_ptr + TTY_STATUS_REG ) );
+                empty  = ( (status & TTY_STATUS_TX_FULL) == 0 );
+
+                if ( empty )  // TTY_TX empty => transfer one byte
+                {
+                    // get one byte from command buffer in client cluster
+                    char byte = (char)hal_remote_lb( buf_xp + i );
+
+                    // write byte to TTY_WRITE_REG in TTY cluster
+                    hal_remote_sb( XPTR( tty_cxy , tty_ptr + TTY_WRITE_REG ) , byte );
+                }
+            } 
+            while ( empty == false );
+        }
+    }
+}  // end soclib_tty_command()
+
+
+////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_tty_isr( device_t * dev )
+{
+    uint32_t   type;         // command type
+    uint32_t   count;        // number of bytes in buffer
+    xptr_t     buf_xp;       // Rextended pointer on buffer
+    uint32_t   status;       // TTY terminal status
+    char       byte;         // read byte
+    uint32_t   i;
+
+
+    // get extended pointer on client thread
+    xptr_t root = XPTR( local_cxy , &dev->wait_root );
+    xptr_t client_xp = XLIST_FIRST_ELEMENT( root , thread_t , wait_list );
+
+    // get client thread cluster and local pointer
+    cxy_t      client_cxy = GET_CXY( client_xp );
+    thread_t * client_ptr = (thread_t *)GET_PTR( client_xp );
+
+    // get command arguments
+    type    = hal_remote_lw ( XPTR( client_cxy , &client_ptr->dev.txt.type   ) );
+    count   = hal_remote_lw ( XPTR( client_cxy , &client_ptr->dev.txt.count  ) );
+    buf_xp  = hal_remote_lwd( XPTR( client_cxy , &client_ptr->dev.txt.buf_xp ) );
+
+    // get SOCLIB_TTY peripheral cluster and local pointer
+    cxy_t      tty_cxy = GET_CXY( dev->base );
+    uint32_t * tty_ptr = (uint32_t *)GET_PTR( dev->base );
+
+    if( type == TXT_READ )              // read one single character
+    {
+        // get TTY_STATUS_REG
+        status = hal_remote_lw( XPTR( tty_cxy , tty_ptr + TTY_STATUS_REG ) );
+
+        if( status & TTY_STATUS_RX_FULL )   // TTY_RX full => transfer one byte
+        {
+            // get a byte from TTY_READ_REG, and acknowledge RX_IRQ
+            byte = (char)hal_remote_lb( XPTR( tty_cxy , tty_ptr + TTY_READ_REG ) );
+
+            // write it to command buffer
+            hal_remote_sb( buf_xp , byte );
+
+            // update TTY_WRITE_REG if echo mode
+            if( CONFIG_TXT_ECHO_MODE )
+            {
+                if( (byte == '\b') || (byte == 0x7F) )
+		        {
+			        hal_remote_sb( XPTR( tty_cxy , tty_ptr + TTY_WRITE_REG ) , '\b' );
+			        hal_remote_sb( XPTR( tty_cxy , tty_ptr + TTY_WRITE_REG ) , ' '  );
+			        hal_remote_sb( XPTR( tty_cxy , tty_ptr + TTY_WRITE_REG ) , '\b' );
+		        }
+                else
+                {
+			        hal_remote_sw( XPTR( tty_cxy , tty_ptr + TTY_WRITE_REG ) , byte );
+		        }
+            }
+        }
+        else                               // buffer empty => exit ISR for retry
+        {
+            return;
+        }
+    }
+    else if( type == TXT_WRITE )         // write a string
+    {
+        // loop on characters 
+        for( i = 0 ; i < count ; i++ )
+        { 
+            // get TTY_STATUS_REG
+            status = hal_remote_lw( XPTR( tty_cxy , tty_ptr + TTY_STATUS_REG ) );
+
+            if( (status & TTY_STATUS_TX_FULL) == 0 ) // TTY_TX empty => transfer one byte
+            {
+                // get one byte from command buffer
+                byte = (char)hal_remote_lb( buf_xp + i );
+
+                // write byte to TTY_WRITE_REG, and acknowledge TX_IRQ
+                hal_remote_sb( XPTR( tty_cxy , tty_ptr + TTY_STATUS_REG ) , byte );
+            }
+            else         // TTY_TX full => update command arguments and exit ISR for retry
+            {
+                // update arguments in command for retry
+                hal_remote_sw ( XPTR( client_cxy , &client_ptr->dev.txt.count )  , count - i ); 
+                hal_remote_swd( XPTR( client_cxy , &client_ptr->dev.txt.buf_xp ) , buf_xp + i );
+                return;
+            }
+        }
+    }
+
+    // The I/O operation completed when we reach this point
+
+    // mask both TTY_RX_IRQ and TTY_TX_IRQ
+    hal_remote_sw( XPTR( tty_cxy , tty_ptr + TTY_CONFIG_REG ) , 0 );
+
+    // set I/O operation status in command
+    hal_remote_sw( XPTR( client_cxy , &client_ptr->dev.txt.error ) , 0 );
+
+    // unblock server thread
+    thread_unblock( XPTR( local_cxy , &dev->server ) , THREAD_BLOCKED_DEV_ISR );
+
+    // unblock client thread
+    thread_unblock( client_xp , THREAD_BLOCKED_IO );
+
+}  // end soclib_tty_isr()
+
+
Index: trunk/kernel/drivers/soclib/soclib_tty.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_tty.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_tty.h	(revision 1)
@@ -0,0 +1,97 @@
+/*
+ * soclib_tty.c - soclib tty driver definition.
+ *
+ * Author  Alain Greiner (2016)
+ *
+ * Copyright (c)  UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <dev_txt.h>
+#include <device.h>
+#include <spinlock.h>
+
+
+/****************************************************************************************
+ * This driver supports the soclib_multi_tty component.
+ * It implements the generic TXT device API:
+ * - transfer one single character from TTY to command "buffer" if to_mem is non-zero.
+ * - transfer "count" characters from command "buffer" to TTY if "to_mem is zero.
+ ***************************************************************************************/
+
+/****************************************************************************************
+ *     SOCLIB_TTY registers offsets  
+ ***************************************************************************************/
+
+#define TTY_WRITE_REG          0
+#define TTY_STATUS_REG         1
+#define TTY_READ_REG           2
+#define TTY_CONFIG_REG         3
+
+#define TTY_SPAN               4       // number of registers per channel
+
+/****************************************************************************************
+ * masks for TTY_STATUS_REG 
+ ***************************************************************************************/
+
+#define TTY_STATUS_RX_FULL     1       // TTY_READ_REG full if 1
+#define TTY_STATUS_TX_FULL     2       // TTY_WRITE_REG full if 1
+
+/****************************************************************************************
+ * masks for TTY_CONFIG_REG 
+ ***************************************************************************************/
+
+#define TTY_CONFIG_RX_ENABLE   1       // TTY_RX IRQ enabled if 1
+#define TTY_CONFIG_TX_ENABLE   2       // TTY_TX IRQ enabled if 1
+
+/****************************************************************************************
+ * This function masks both the TTY_RX and TTY_TX IRQs from the SOCLIB_TTY device.
+ * Thes IRQs are unmasked by the soclib_tty_cmd() function.
+ ****************************************************************************************
+ * @ dev     : extended pointer on the generic TXT device descriptor.
+ ***************************************************************************************/
+extern void soclib_tty_init( xptr_t dev_xp );
+
+/****************************************************************************************
+ * This function handles the command registered in the thread descriptor identified
+ * by the <xp_thread> argument.
+ * - For the TXT_READ and TXT_WRITE commands, it only unmask the proper TTY_RX / TTY_TX
+ *   IRQ, and blocks the TXT device server thread on the THREAD_BLOCKED_DEV_ISR, as the
+ *   data transfer is done by the ISR.
+ * - For the TXT_SYNC_READ command, that should be only used by the kernel do display
+ *   log or debug messages, it directly access the SOCLIB_TTY registers, using
+ *   a busy waiting policy if required.
+ ****************************************************************************************
+ * @ xp_thread : extended pointer on client thread descriptor.
+ ***************************************************************************************/
+extern void soclib_tty_command( xptr_t thread_xp );
+
+/****************************************************************************************
+ * This ISR should be executed only for the TXT_READ and TXT_WRITE commands.
+ * It get the command arguments from the first client thread in the TXT device queue:
+ * - if TXT_READ, it transfer one byte from the TTY_READ_REG to the command buffer.
+ *   It simply returns for retry if TTY_READ_REG is empty.
+ * - if TXT_WRITE, it tries to transfer several bytes from the command buffer to the 
+ *   TTY_WRITE_REG. If the TTY_WRITE_REG is full, it updates the "count" and "buffer" 
+ *   command arguments and returns for retry.
+ * When the I/O operation is completed, it set the status field in the command, unblock
+ * the server thread, and unblock the client thread. 
+ ****************************************************************************************
+ * @ dev     : local pointer on generic TXT device descriptor.
+ ***************************************************************************************/
+extern void soclib_tty_isr( device_t * dev );
+
Index: trunk/kernel/drivers/soclib/soclib_xcu.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_xcu.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_xcu.c	(revision 1)
@@ -0,0 +1,156 @@
+/*
+ * soclib_xcu.c - soclib XCU driver API implementation.
+ *
+ * Authors  Alain Greiner    (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <soclib_xcu.h>
+#include <hal_types.h>
+#include <core.h>
+#include <device.h>
+
+
+
+/////////////////////////////////////
+void soclib_xcu_init( device_t * icu,
+                      lid_t      lid )
+{
+    // get local ICU segment base address
+	uint32_t * base = (uint32_t *)GET_PTR( icu->base );
+
+    // write into registers
+    base[XCU_MSK_HWI_DISABLE << 5 | lid] = 0xFFFFFFFF;
+    base[XCU_MSK_WTI_DISABLE << 5 | lid] = 0xFFFFFFFF;
+    base[XCU_MSK_PTI_DISABLE << 5 | lid] = 0xFFFFFFFF;
+}
+
+///////////////////////////////////////////////
+void soclib_xcu_disable_irq( xptr_t     icu_xp,
+                             uint32_t   mask,
+                             uint32_t   type,
+                             lid_t      lid )
+{
+    // get remote ICU cluster and local pointer
+    cxy_t      icu_cxy = GET_CXY( icu_xp );
+    device_t * icu_ptr = (device_t *)GET_PTR( icu_xp );
+
+    // get remote XCU segment base address
+	xptr_t base = (xptr_t)hal_remote_lwd( XPTR( icu_cxy , &icu_ptr->base ) );
+
+    // compute xptr on relevant XCU mask register
+    xptr_t   reg_xp;
+	if     ( type == WTI_TYPE ) reg_xp = base + ((XCU_MSK_WTI_DISABLE << 5 | lid)<<2);
+	else if( type == HWI_TYPE ) reg_xp = base + ((XCU_MSK_HWI_DISABLE << 5 | lid)<<2);
+	else                        reg_xp = base + ((XCU_MSK_PTI_DISABLE << 5 | lid)<<2);
+
+    // reset relevant XCU mask register
+	hal_remote_sw( reg_xp , mask );
+}
+
+//////////////////////////////////////////////
+void soclib_xcu_enable_irq( xptr_t     icu_xp,
+                            uint32_t   mask,
+                            uint32_t   type,
+                            lid_t      lid )
+{
+    // get remote ICU cluster and local pointer
+    cxy_t      icu_cxy = GET_CXY( icu_xp );
+    device_t * icu_ptr = (device_t *)GET_PTR( icu_xp );
+
+    // get remote XCU segment base address
+	xptr_t base = (xptr_t)hal_remote_lwd( XPTR( icu_cxy , &icu_ptr->base ) );
+
+    // compute xptr on relevant XCU mask register
+    xptr_t   reg_xp;
+	if     ( type == WTI_TYPE ) reg_xp = base + ((XCU_MSK_WTI_ENABLE << 5 | lid)<<2);
+	else if( type == HWI_TYPE ) reg_xp = base + ((XCU_MSK_HWI_ENABLE << 5 | lid)<<2);
+	else                        reg_xp = base + ((XCU_MSK_PTI_ENABLE << 5 | lid)<<2);
+
+    // set relevant XCU mask register
+	hal_remote_sw( reg_xp , mask );
+}
+
+///////////////////////////////////////////
+void soclib_xcu_set_period( device_t * icu,
+                            uint32_t   index,
+                            uint32_t   period )
+{
+    // get local ICU segment base address
+	uint32_t * base = (uint32_t *)GET_PTR( icu->base );
+
+    // write into register
+    base[XCU_PTI_PER << 5 | index] = period;
+}
+
+//////////////////////////////////////////////
+uint32_t soclib_xcu_ack_timer( device_t * icu,
+                               uint32_t   index )
+{
+    // get local ICU segment base address
+	uint32_t * base = (uint32_t *)GET_PTR( icu->base );
+
+    // read from register
+	return base[XCU_PTI_ACK << 5 | index];
+}
+
+///////////////////////////////////////////////
+void soclib_xcu_get_status( device_t * icu,
+                            lid_t      lid,
+                            uint32_t * hwi_status,
+                            uint32_t * wti_status,
+                            uint32_t * pti_status )
+{
+    // get local ICU segment base address 
+    uint32_t * base = (uint32_t *)GET_PTR( icu->base );
+
+    // read PRIO register
+	uint32_t prio = base[XCU_PRIO << 5 | lid];
+
+    if( prio & 0x4 ) *wti_status = ((prio >> 24) & 0x1F) + 1;
+    if( prio & 0x2 ) *hwi_status = ((prio >> 16) & 0x1F) + 1;
+    if( prio & 0x1 ) *pti_status = ((prio >>  8) & 0x1F) + 1;
+}
+
+/////////////////////////////////////////
+void soclib_xcu_send_ipi( xptr_t  xp_icu,
+                          lid_t   lid )
+{
+    // get target ICU device cluster and local pointer
+    cxy_t       cxy_icu = GET_CXY( xp_icu );
+    device_t  * ptr_icu = (device_t *)GET_PTR( xp_icu );
+
+    // get extended pointer on target ICU segment base
+    xptr_t  xp_base = (xptr_t)hal_remote_lwd( XPTR( cxy_icu , &ptr_icu->base ) );
+
+    // get remote ICU segment local pointer 
+	uint32_t  * base = (uint32_t *)GET_PTR( xp_base );
+
+    // send IPI to remote core
+	hal_remote_sw( XPTR( cxy_icu , &base[XCU_WTI_REG << 5 | lid] ) , 0 );
+}
+
+//////////////////////////////////////////////
+uint32_t * soclib_xcu_wti_ptr( device_t * icu,
+                               uint32_t   index )
+{
+    uint32_t * base = (uint32_t *)GET_PTR( icu->base );
+
+    return &base[XCU_WTI_REG << 5 | index];
+}
